/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package com.unis.grainReserves.modular.gopsPlan.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.unis.grainReserves.modular.gopsPlan.entity.GopsPlan;
import com.unis.grainReserves.modular.gopsPlan.param.*;

import java.util.List;
import java.util.Map;

/**
 * 购销计划Service接口
 *
 * @author QSHan
 * @date  2024/05/18 17:25
 **/
public interface GopsPlanService extends IService<GopsPlan> {

    /**
     * 获取购销计划分页
     *
     * @author QSHan
     * @date  2024/05/18 17:25
     */
    Page<GopsPlan> page(GopsPlanPageParam gopsPlanPageParam);

    /**
     * 添加购销计划
     *
     * @author QSHan
     * @date  2024/05/18 17:25
     */
    void add(GopsPlanAddParam gopsPlanAddParam);

    /**
     * 编辑购销计划
     *
     * @author QSHan
     * @date  2024/05/18 17:25
     */
    void edit(GopsPlanEditParam gopsPlanEditParam);

    /**
     * 删除购销计划
     *
     * @author QSHan
     * @date  2024/05/18 17:25
     */
    void delete(List<GopsPlanIdParam> gopsPlanIdParamList);

    /**
     * 获取购销计划详情
     *
     * @author QSHan
     * @date  2024/05/18 17:25
     */
    GopsPlan detail(GopsPlanIdParam gopsPlanIdParam);

    /**
     * 获取购销计划详情
     *
     * @author QSHan
     * @date  2024/05/18 17:25
     **/
    GopsPlan queryEntity(String id);

    Map<String, Object> getListDetail(GopsPlanDetail param);

    Page<List<Map<String, Object>>> getPlanRatePage(GopsPlanPageParam param);

    List<Map<String, Object>> getEnumTreeList(Integer parentId);

    List<Map<String, Object>> getStoreHouseList(Integer orgId);

    List<Map<String, Object>> getWarehouseList(Integer storehouseId);

    List<Map<String, Object>> getOrgIdList();

    int getCollectionsToUpdate(List<GopsPlan> collections);
}
